#import "KangbangController.h"

@implementation KangbangController

- (id)init
{
   if((self=[super init]) != nil){
      [self initRandomizer];
   }
   return self;
}

-(void)initRandomizer
{
   randomBox=[[Randomizer alloc] initWithMax:100 onlyUnique:false];
}

-(void)dealloc
{
   [randomBox dealloc];
   [super dealloc];
}

- (IBAction)pick:(id)sender
{
   int returnedValue;
   
   returnedValue = [randomBox getRandomNumber];
   
   [self logAppend:[NSString stringWithFormat:@"picked: %d",returnedValue]];
   [resultDrawing setNumber:returnedValue];
}

- (IBAction)openInitPanel:(id)sender
{
   [NSApp beginSheet: initPanel modalForWindow:mainWindow modalDelegate:self
      didEndSelector: @selector(closeInitPanel:returnCode:contextInfo:)
         contextInfo:nil];
}

- (void)closeInitPanel:(NSPanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo
{
   [sheet orderOut:self];
}

- (IBAction)initPushed:(id)sender
{
   int fieldValue;
   BOOL unique;
   
   // Get value
   fieldValue=[resultField intValue];
   unique=([uniqueCheckbox state]==NSOnState);
   
   // Error check, if fieldValue<1, set it to 1 and don't close the sheet
   if(fieldValue<1)
    {
      [resultField setIntValue:1];
      return;
    }
   
   // Initialize randomBox with the value we just got;
   [randomBox release];
   randomBox=[[Randomizer alloc] initWithMax:fieldValue onlyUnique:unique];

   [NSApp endSheet:initPanel];
   [self logAppend:[NSString stringWithFormat:@"Initialized, max=%d, unique=%@",fieldValue,unique?@"true":@"false"]];
}

- (IBAction)initCancelled:(id)sender
{
   [NSApp endSheet:initPanel];
}

- (IBAction)toggleLogDrawer:(id)sender
{
   NSDrawerState state = [logDrawer state];
   if (NSDrawerOpeningState == state || NSDrawerOpenState == state) {
      [logDrawer close];
   } else {
      [logDrawer open];
   }   
}

- (IBAction)markLog:(id)sender
{
   [self logAppend:@"--- MARKED ---"];
}

- (IBAction)clearLog:(id)sender
{
   [logField setString:@""];
}

- (void)logAppend:(id)str
{
   
   [logField insertText:
      [NSString stringWithFormat:@"[%@] %@\n",[[NSDate date] description],str]];
}
@end
