/* Randomizer */
#define N 624
#define M 397

#import <Cocoa/Cocoa.h>

@interface Randomizer : NSObject
{
   int maximum;
   BOOL *mask;
   BOOL unique;
   
   unsigned long mt[N]; /* the array for the state vector  */
   int mti; /* mti==N+1 means mt[N] is not initialized */
}

/* Period parameters */  
static const long MATRIX_A=0x9908b0dfUL;   /* constant vector a */
static const long UPPER_MASK=0x80000000UL; /* most significant w-r bits */
static const long LOWER_MASK=0x7fffffffUL; /* least significant r bits */

-(void) init_genrand:(unsigned long) s;
-(void) init_by_array:(unsigned long*) init_key length:(int) key_length;
-(unsigned long) genrand_int32;
-(long) genrand_int31;
-(double) genrand_real1;
-(double) genrand_real2;
-(double) genrand_real3;
-(double) genrand_res53;

-(id) initWithMax:(int) max onlyUnique:(BOOL)u;
-(int) getRandomNumber;
-(BOOL) checkFilledAfter:(int)index;
@end
